 
import CallbackAdv.*;
import org.omg.CORBA.*;

class TestServant extends _TestImplBase {
    
    private int actclient;
    private XCallback[] clients;
    private String[] registeredclients;
    private int nmbr;

    TestServant() {
        nmbr = 0;
        actclient = 0;
        clients = new XCallback[10];
        registeredclients = new String[10];
        System.out.println("TestServant started");
    }

    public void regist(XCallback callobj, String clname) {
        registeredclients[actclient] = clname;
        clients[actclient++] = callobj;
        callobj.callback(nmbr);
        System.out.println("actual clients:"); 
        for(int i = 0; i < actclient; i++) {
            System.out.println(registeredclients[i]);
        }
    }

    public void finish(String clname) {
        int j = actclient - 1;
        if (actclient > 0) {
           while ((j >= 0) && (registeredclients[j].compareTo(clname) != 0)) {
              j--;
           }
           if (j >= 0) {
              for (int k = j; k < actclient; k++) {
                  clients[k] = clients[k + 1];
                  registeredclients[k] = registeredclients[k + 1];
              }
              actclient--;
              System.out.println("actual clients:"); 
              for(int i = 0; i < actclient; i++) {
                 System.out.println(registeredclients[i]);
              }   
           }
        }        
    }

    public void add(int i) {
        nmbr += i;
        int j = actclient;
        while (j > 0) clients[--j].callback(nmbr);
    }
}


